Subject: Re: What's cooking in git.git (Dec 2025, #06)

From: Patrick Steinhardt <[email-masked]>
Date: Sat, 20 Dec 2025 10:32:02 +0100

On Sat, Dec 20, 2025 at 01:47:45AM +0900, Junio C Hamano wrote:
> * ps/odb-misc-fixes (2025-12-10) 3 commits
>  - odb: properly close sources before freeing them
>  - builtin/gc: fix condition for whether to write commit graphs
>  - Merge branch 'ps/object-source-management' into ps/odb-misc-fixes
>  (this branch is used by ps/packfile-store-in-odb-source.)
> 
>  Miscellaneous fixes on object database layer.
> 
>  Comments?
>  source: <[email-masked]>

Given that this series is somewhat small and has received two favorable
reviews I'd suggest that this can probably be merged down to "next".

> * ps/clar-integers (2025-12-06) 3 commits
>  - gitattributes: disable blank-at-eof errors for clar test expectations
>  - t/unit-tests: demonstrate use of integer comparison assertions
>  - t/unit-tests: update clar to 39f11fe
> 
>  Import newer version of "clar", unit testing framework.
> 
>  Comments?
>  source: <[email-masked]>

I think this can be merged, too. Peff has positively reviewed the update
itself, the only change relative to that in v2 was to mark the self-test
files as being allowed to end in a blank line via gitattributes.

> * kn/ref-location (2025-12-01) 2 commits
>  - refs: add GIT_REF_URI to specify reference backend and directory
>  - refs: support obtaining ref_store for given dir
> 
>  A mechanism to specify what reference backend to use and store
>  references in which directory is introduced, which would likely to
>  be useful during ref migration.
> 
>  Comments?
>  source: <[email-masked]>

I somehow lost track of reviewing this topic. I've put it into my
backlog of stuff to review once I'm back in office (or when I find a
quiet minute where I'm bored).

> * ar/run-command-hook (2025-12-18) 11 commits
>  - receive-pack: convert receive hooks to hook API
>  - receive-pack: convert update hooks to new API
>  - hooks: allow callers to capture output
>  - run-command: allow capturing of collated output
>  - hook: allow overriding the ungroup option
>  - reference-transaction: use hook API instead of run-command
>  - transport: convert pre-push to hook API
>  - hook: convert 'post-rewrite' hook in sequencer.c to hook API
>  - hook: provide stdin via callback
>  - run-command: add stdin callback for parallelization
>  - run-command: add first helper for pp child states
> 
>  Use hook API to replace ad-hoc invocation of hook scripts with the
>  run_command() API.
> 
>  Will merge to 'next'?
>  cf. <[email-masked]>
>  source: <[email-masked]>

There's a small set of nits I had on the final patch, but I don't really
think these necessarily need to be addressed. I'll leave it to Adrian to
decide whether or not he wants to do a final reroll.

> * ps/history (2025-12-03) 13 commits
>  - builtin/history: implement "split" subcommand
>  - cache-tree: allow writing in-memory index as tree
>  - add-patch: allow disabling editing of hunks
>  - add-patch: add support for in-memory index patching
>  - add-patch: remove dependency on "add-interactive" subsystem
>  - add-patch: split out `struct interactive_options`
>  - add-patch: split out header from "add-interactive.h"
>  - builtin/history: implement "reword" subcommand
>  - builtin: add new "history" command
>  - replay: stop using `the_repository`
>  - replay: extract logic to pick commits
>  - wt-status: provide function to expose status for trees
>  - Merge branch 'pw/replay-exclude-gpgsig-fix' into ps/history
>  (this branch is used by pw/replay-drop-empty.)
> 
>  "git history" history rewriting UI.
> 
>  What's the status of this topic?
>  source: <[email-masked]>

I didn't find the time recently to focus on this topic. I think the
discussions mostly reached consensus though that we also want to adapt
these commands to rewrite dependent branches. I'll work this into the
series, but will probably only get to it in early January.

Thanks!

Patrick